SystemOrganization addCategory: #GraphAlgorithms!

Object subclass: #GraphAlgorithms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphAlgorithms methodsFor: 'public - hooks' stamp: 'Deniels 12/21/2011 21:16'!
applyOn: nodes! !

!GraphAlgorithms methodsFor: 'public - hooks' stamp: 'Deniels 12/21/2011 21:18'!
applyOn: nodes startNode: startNode! !

!GraphAlgorithms methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 16:29'!
highlight: nodes
	self applyOn: nodes.
	! !

GraphAlgorithms subclass: #GraphFindFreeNodes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindFreeNodes methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 16:31'!
applyOn: nodes
	"find all free nodes (i.e., a node that does not have an icoming and outgoing edge)"

	^ nodes select: [ :n | (n incomingEdges isEmpty) and: [ n outgoingEdges isEmpty ] ].
	! !

!GraphFindFreeNodes methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 16:50'!
highlight: nodes
	(self applyOn: nodes) do: [ :node | node copyShapeAndDo: [ :shape | shape fillColor: Color red ]]! !

GraphAlgorithms subclass: #GraphFindMostFanInNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindMostFanInNode methodsFor: 'public - hooks' stamp: 'Deniels 12/21/2011 21:07'!
applyOn: nodes
	"find a node that has the most incomingEdges"
	
	|maxFanIn theNodes|
	maxFanIn := 0.
	theNodes := OrderedCollection new.
	nodes do:[:n | (n incomingEdges size > maxFanIn) ifTrue:[theNodes reset. theNodes add: n. maxFanIn := n incomingEdges size] ifFalse:[(n incomingEdges size = maxFanIn) ifTrue: [theNodes add: n. maxFanIn := n incomingEdges size]]].
	^theNodes! !

!GraphFindMostFanInNode methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 22:35'!
highlight: nodes
	(self applyOn: nodes) do: [ :node | node copyShapeAndDo: [ :shape | shape fillColor: Color red ]]! !

GraphAlgorithms subclass: #GraphFindMostFanOutNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindMostFanOutNode methodsFor: 'public - hooks' stamp: 'Deniels 12/21/2011 21:10'!
applyOn: nodes
	"find a node that has the most incomingEdges"
	
	|maxFanOut theNodes|
	maxFanOut := 0.
	theNodes := OrderedCollection new.
	nodes do:[:n | (n outgoingEdges size > maxFanOut) ifTrue:[theNodes reset. theNodes add: n. maxFanOut := n outgoingEdges size] ifFalse:[(n outgoingEdges size = maxFanOut) ifTrue: [theNodes add: n. maxFanOut := n outgoingEdges size]]].
	^theNodes! !

!GraphFindMostFanOutNode methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 22:41'!
highlight: nodes
	(self applyOn: nodes) do: [ :node | node copyShapeAndDo: [ :shape | shape fillColor: Color red ]]! !

GraphAlgorithms subclass: #GraphFindTheLongestPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindTheLongestPath methodsFor: 'public - hooks' stamp: 'Deniels 12/21/2011 21:18'!
applyOn: nodes startNode: startNode! !

TestCase subclass: #GraphAlgorithmsTest
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphAlgorithmsTest methodsFor: 'running' stamp: 'Deniels 12/21/2011 21:03'!
setUp 
	|view|
	view := MOViewRenderer new.
	nodes :=view nodes: (1 to: 6).
	view edgesFromAssociations: {
		"the node 3 is free"
		"the node 1 has more than others outgoingEdges"
		"the node 5 has more than others incomingEdges"
		1 -> 2.
		1 -> 4.
		2 -> 5.
		1 -> 5
	}.! !

!GraphAlgorithmsTest methodsFor: 'tests' stamp: 'Deniels 12/20/2011 16:31'!
testGraphFindFreeNodes 
 	| res |
	res := GraphFindFreeNodes new applyOn: nodes.
	self assert: res asArray = { nodes third . nodes sixth }! !

!GraphAlgorithmsTest methodsFor: 'tests' stamp: 'Deniels 12/21/2011 21:08'!
testGraphFindMostFanInNode
	| res |
	res := GraphFindMostFanInNode new applyOn: nodes.
	self assert: res asArray = { nodes fifth }! !

!GraphAlgorithmsTest methodsFor: 'tests' stamp: 'Deniels 12/20/2011 16:31'!
testGraphFindMostFanOutNode
	| res |
	res := GraphFindMostFanOutNode new applyOn: nodes.
	self assert: res asArray = { nodes first }
	! !

TestCase subclass: #GraphAlgorithmsTest2
	instanceVariableNames: 'nodes startNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphAlgorithmsTest2 methodsFor: 'running' stamp: 'Deniels 12/21/2011 20:57'!
setUp 
	"No free nodes
	the node 1 and 2 has more than others outgoingEdges
	the node 2 has more than others incomingEdges"

	|view|
	view := MOViewRenderer new.
	nodes :=view nodes: (1 to: 6).
	view edgesFromAssociations: {
		1 -> 2.
		1 -> 6.
		6 -> 2.
		2 -> 3.
		2 -> 4.
		4 -> 5
	}.! !

!GraphAlgorithmsTest2 methodsFor: 'tests' stamp: 'Deniels 12/21/2011 20:57'!
testGraphFindFreeNodes 
 	| res |
	res := GraphFindFreeNodes new applyOn: nodes.
	self assert: res asArray = { }! !

!GraphAlgorithmsTest2 methodsFor: 'tests' stamp: 'Deniels 12/21/2011 21:09'!
testGraphFindMostFanInNode
	| res |
	res := GraphFindMostFanInNode new applyOn: nodes.
	self assert: res asArray = { nodes second }! !

!GraphAlgorithmsTest2 methodsFor: 'tests' stamp: 'Deniels 12/21/2011 21:11'!
testGraphFindMostFanOutNode
	| res |
	res := GraphFindMostFanOutNode new applyOn: nodes.
	self assert: res asArray = { nodes first . nodes second}
	! !

!GraphAlgorithmsTest2 methodsFor: 'tests' stamp: 'Deniels 12/21/2011 21:39'!
testGraphFindTheLongestPath
	| res |
	res := GraphFindTheLongestPath new applyOn: nodes startNode: startNode.
	self assert: res asArray = { nodes first . nodes sixth . nodes second . nodes fourth . nodes fifth}! !
